unit fastshutdown_main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,
  setregistry;

type
  TForm1 = class(TForm)
    ButtonOk: TButton;
    ButtonNormal: TButton;
    ButtonSchnell: TButton;
    Label1: TLabel;
    Label2: TLabel;
    EditVersuche: TEdit;
    EditTimeout: TEdit;
    procedure ButtonSchnellClick(Sender: TObject);
    procedure ButtonNormalClick(Sender: TObject);
    procedure ButtonOkClick(Sender: TObject);
  private
    setregistry: Tsetregistry;
  end;

var
  Form1: TForm1;

implementation


{$R *.dfm}

procedure TForm1.ButtonOkClick(Sender: TObject);
var
  liste:TStringList;
begin
  liste:=TStringList.Create;
// Wiederholversuche zum speichern des User-Profiles von 60 mal (jede Sekunde 1x) auf 3 mal runterschrauben
  liste.Add('SOFTWARE\Policies\Microsoft\Windows\System\ProfileUnloadTimeout=REG_DWORD:'+editVersuche.Text);

  // Timeout zum killen von hngenden Diensten von 20s auf 3s runtersetzen
  liste.Add('System\CurrentControlSet\Control\WaitToKillServiceTimeout=REG_SZ:'+EditTimeout.Text);

  //Registry setzen
  setregistry:=Tsetregistry.Create;
  setregistry.setze(liste);
  setregistry.Free;
  liste.Free;
  Close;
end;

procedure TForm1.ButtonNormalClick(Sender: TObject);
begin
  EditVersuche.Text:='60';
  EditTimeout.Text:='20000';
end;

procedure TForm1.ButtonSchnellClick(Sender: TObject);
begin
  EditVersuche.Text:='3';
  EditTimeout.Text:='3000';
end;

end.
