unit setregistry;

interface
uses Classes, SysUtils, Windows, Forms, Dialogs, inifiles;
type

  Tsetregistry= class
  public
    procedure setze(entries:TStringlist);
  end;

implementation

{ Tsetregistry }

procedure Tsetregistry.setze(entries:TStringlist);
var
  keyHandle:hKey;
  result:longint;
  dwordval:dword;
  i:Integer;
  p:Integer;
  typUndWertTxt:string;
  wertTxt:string;
  pfad:string;
  element:string;
  typ:string;

begin
  for i:=0 to entries.Count-1
  do begin
     typUndWertTxt:=entries[i];
     pfad:=ExtractFilePath(entries[i]);
     pfad:=Copy(pfad,1,Length(pfad)-1); //abschliessenden \ entfernen
     element:=ExtractFileName(entries[i]);
     p:=Pos(':',typUndWertTxt);
     typ:=Copy(typUndWertTxt,1,p-1);
     wertTxt:=Copy(typUndWertTxt,p+1,99);

     Result:=RegOpenKeyEx(HKEY_LOCAL_MACHINE,
               pchar(pfad),
               0,
               KEY_SET_VALUE,
               keyHandle  );
     if ERROR_SUCCESS=Result then begin

       if typ='REG_DWORD' then begin
         dwordval:=strToInt(wertTxt);
         result:=RegSetValueEx(keyHandle,
                     pchar(element),
                     0,
                     REG_DWORD,
                     @dwordval,
                     4);
         if Result<>0 then MessageDlg('Tsetregistry.setze: Setzen fehlgeschlagen ['+element+']', mtWarning, [mbOK], 0);
       end else
       if typ='REG_SZ' then begin
         result:=RegSetValueEx(keyHandle,
                     pchar(element),
                     0,
                     REG_DWORD,
                     @wertTxt,
                     Length(wertTxt));
         if Result<>0 then MessageDlg('Tsetregistry.setze: Setzen fehlgeschlagen ['+element+']', mtWarning, [mbOK], 0);

       end else MessageDlg('Unknown Registry data type in Tsetregistry.setze', mtError, [mbOK], 0);
     end;
  end;
end;

end.
